package org.processmining.indatabasepreprocessing.parameters;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.elements.Place;

public class Rule {
	public Set<Set<Place>> placesOfARule;
	public HashMap<String, Integer> eventClassToInt;
	public HashMap<Integer, AbstractMap.SimpleEntry<ArrayList<Integer>,ArrayList<Integer>>> rules;
	public HashMap<Integer, AbstractMap.SimpleEntry<AbstractMap.SimpleEntry<Integer,ArrayList<Integer>>, ArrayList<Integer>>> rulesWithToken;
	public HashMap<Integer, ArrayList<Integer>> rulesOfaLabel;
	public HashMap<Integer, ArrayList<Integer>> rulesTokenOfaLabel;
	
	public Rule() {
		placesOfARule = new HashSet<Set<Place>>();
		rules = new HashMap<Integer, AbstractMap.SimpleEntry<ArrayList<Integer>,ArrayList<Integer>>>();
		eventClassToInt = new HashMap<String, Integer>();
		rulesWithToken =  new HashMap<Integer, AbstractMap.SimpleEntry<AbstractMap.SimpleEntry<Integer,ArrayList<Integer>>, ArrayList<Integer>>>();
		rulesOfaLabel = new HashMap<Integer, ArrayList<Integer>>();
		rulesTokenOfaLabel = new HashMap<Integer, ArrayList<Integer>>();
	}
	
	public String ruleToString() {
		String rulesString = "";
				
		for(Integer ruleNumber : rules.keySet()) {
			AbstractMap.SimpleEntry<ArrayList<Integer>,ArrayList<Integer>> pair = rules.get(ruleNumber);
			ArrayList<Integer> in = pair.getKey();
			ArrayList<Integer> out = pair.getValue();
			
			String ruleString = "";
			for(int i = 0; i < in.size(); i++) {
				ruleString = ruleString + in.get(i) + ",";				
			}
			ruleString = ruleString + "=";
			for(int i = 0; i < out.size(); i++) {
				ruleString = ruleString + out.get(i) + ",";				
			}
			rulesString = rulesString + ruleNumber + ">>" + ruleString + ";";
		}
		
		return rulesString;
	}
	
	public String ruleWithTokenToString() {
		String rulesString = "";
		
		for(Integer ruleNumber : rulesWithToken.keySet()) {
			AbstractMap.SimpleEntry<AbstractMap.SimpleEntry<Integer,ArrayList<Integer>>, ArrayList<Integer>> pair = rulesWithToken.get(ruleNumber);
			AbstractMap.SimpleEntry<Integer,ArrayList<Integer>> pairTokenIn = pair.getKey();
			ArrayList<Integer> out = pair.getValue();
			Integer token = pairTokenIn.getKey();
			ArrayList<Integer> in = pairTokenIn.getValue();
			
			String ruleString = "";
			ruleString = ruleString + token + "=";
			for(int i = 0; i < in.size(); i++) {
				ruleString = ruleString + in.get(i) + ",";				
			}
			ruleString = ruleString + "=";
			for(int i = 0; i < out.size(); i++) {
				ruleString = ruleString + out.get(i) + ",";				
			}
			rulesString = rulesString + ruleNumber + ">>" + ruleString + ";";
			
		}
		
		return rulesString;
	}
	
	public String eventClassIntToString() {
		String mapString = "";
		
		for(String activity : eventClassToInt.keySet()) {
			Integer intActivity = eventClassToInt.get(activity);
			mapString = mapString + activity + "=" + intActivity + ";";
		}
		
		return mapString;
	}
	
	public String ruleOfALabelToString() {
		String ruleOfLabelString = "";
		
		for(Integer activity : rulesOfaLabel.keySet()) {
			ArrayList<Integer> ruleNumbers = rulesOfaLabel.get(activity);
			
			String ruleNumbersString = "";
			for(int i = 0; i < ruleNumbers.size(); i++) {
				ruleNumbersString  = ruleNumbersString + ruleNumbers.get(i) + ",";
			}
			
			ruleOfLabelString = ruleOfLabelString + activity + "=" + ruleNumbersString + ";";
		}
		
		return ruleOfLabelString;
	}
	
	public String ruleTokenOfALabelToString() {
		String ruleOfLabelString = "";
		
		for(Integer activity : rulesTokenOfaLabel.keySet()) {
			ArrayList<Integer> ruleNumbers = rulesTokenOfaLabel.get(activity);
			
			String ruleNumbersString = "";
			for(int i = 0; i < ruleNumbers.size(); i++) {
				ruleNumbersString  = ruleNumbersString + ruleNumbers.get(i) + ",";
			}
			
			ruleOfLabelString = ruleOfLabelString + activity + "=" + ruleNumbersString + ";";
		}
		
		return ruleOfLabelString;
	}
	
}
